<!--
  -    Copyright 2014-2023 IHE International
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html" xmlns="http://www.w3.org/1999/xhtml">
    <h:panelGroup rendered="#{instructionManager.displayAuditMessages}">
        <div role="tabpanel" class="tab-pane" id="auditMessageTab">

            <s:div rendered="#{empty managedBean.auditedEvents}" styleClass="gzl-alert gzl-alert-blue">
                <span class="fa fa-info"></span>
                <h:outputText
                        value="#{messages['net.ihe.gazelle.questionnaire.ThisSystemIsNotRequiredToProduceAuditMessages']}"/>
            </s:div>

            <s:div rendered="#{not empty managedBean.questionnaire.auditedEvent}">
                <h:form id="auditMessagesForm">
                    <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

                    <ui:include src="#{instructionFile}">
                        <ui:param name="instructionToDisplay" value="#{managedBean.auditMessagesInstructions}"/>
                    </ui:include>

                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                        <div class="form-horizontal">
                            <div class="row">
                                <div class="col-md-6">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{managedBean.eventFilter}"/>
                                        <ui:param name="filterId" value="actor"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.questionnaire.IssuingActor']}"/>
                                        <ui:param name="filterForm" value="auditMessagesForm"/>
                                    </ui:include>
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{managedBean.eventFilter}"/>
                                        <ui:param name="filterId" value="transaction"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.questionnaire.AuditedTransaction']}"/>
                                        <ui:param name="filterForm" value="auditMessagesForm"/>
                                    </ui:include>
                                </div>
                                <div class="col-md-6">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{managedBean.eventFilter}"/>
                                        <ui:param name="filterId" value="produced"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.questionnaire.ProducedBySystem']}"/>
                                        <ui:param name="filterForm" value="auditMessagesForm"/>
                                    </ui:include>
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{managedBean.eventFilter}"/>
                                        <ui:param name="filterId" value="status"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.questionnaire.ValidationStatus']}"/>
                                        <ui:param name="filterForm" value="auditMessagesForm"/>
                                    </ui:include>
                                </div>
                            </div>
                        </div>
                        <ui:define name="filter_buttons">
                            <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.ResetCriteria']}"
                                             actionListener="#{managedBean.clearEventFilter()}"
                                             render="auditMessagesForm">
                                <span class="fa fa-times-circle"></span>
                            </a4j:commandLink>
                        </ui:define>
                    </ui:decorate>

                    <h:panelGroup rendered="#{displaySaveButton}">
                        <p>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.questionnaire.SetAllSelectedAuditMessagesTo']} "/>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.questionnaire.Implemented']}"
                                               styleClass="gzl-btn-green btn-sm"
                                               actionListener="#{atnaQuestionnaireEditor.markAllEntriesAsProduced()}"
                                               title="#{messages['net.ihe.gazelle.questionnaire.SetAllSelectedAuditMessagesToImplemented']}"
                                               render="auditMessagesForm,questDetails,gazelle-messages"/>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.questionnaire.NotImplemented']}"
                                               styleClass="gzl-btn-red btn-sm"
                                               title="#{messages['net.ihe.gazelle.questionnaire.SetAllSelectedAuditMessagesToNotImplemented']}"
                                               actionListener="#{atnaQuestionnaireEditor.markAllEntriesAsNotProduced()}"
                                               render="auditMessagesForm,questDetails,gazelle-messages"/>
                        </p>
                    </h:panelGroup>

                    <ui:include src="#{auditMessageTableFile}">
                        <ui:param name="auditMessages" value="#{managedBean.getAuditedEvents()}"/>
                    </ui:include>

                    <a4j:commandButton actionListener="#{managedBean.saveAuditedEvents()}"
                                       value="#{messages['net.ihe.gazelle.questionnaire.SaveAuditMessages']}"
                                       rendered="#{displaySaveButton}" styleClass="gzl-btn-blue"
                                       render="auditMessagesForm,questDetails,gazelle-messages"/>
                </h:form>
            </s:div>
        </div>
    </h:panelGroup>
</ui:composition>
